//======================================================================
// Copyright (C) 2002 Daniel Heck
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License along
// with this program; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
//======================================================================
#ifndef PX_FONT_HH
#define PX_FONT_HH

namespace px
{
    class GC;
    class Surface;

    class Font {
    public:
	virtual ~Font() {}

        virtual int get_lineskip() =0;
	virtual int get_height() = 0;

	virtual int get_width(char c) = 0;
	virtual int get_width(const char *str)=0;

	virtual Surface *render(const char *str) = 0;
        virtual void render(const GC &gc, int x, int y, 
                            const char *str) = 0;
    };

    Font *LoadBitmapFont(const char * filename,
                         const char * descrname);
}
#endif
