/*
 * Copyright (C) 2002,2003 Daniel Heck
 *
 * This program is free software; you can redistribute it and/ or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * $Id: stones_internal.hh,v 1.4 2003/07/21 08:22:02 reallysoft Exp $
 */
#ifndef STONES_INTERNAL_HH_INCLUDED
#define STONES_INTERNAL_HH_INCLUDED

#ifndef FWD_HH
#include "fwd.hh"
#endif

namespace stones
{
    void Init_simple();
    void Init_complex();

    // allows to completely remove a Stone and its model
    // for a short time
    //
    // - "delays" animation
    //
    // @@@ FIXME: alarms have to be disabled as well

    class YieldedGridStone {
        world::Stone   *stone;
        display::Model *model;

        YieldedGridStone(const YieldedGridStone&);
        YieldedGridStone& operator = (const YieldedGridStone&);
    public:

        YieldedGridStone(world::Stone *st);
        ~YieldedGridStone();

        void set_stone(enigma::GridPos pos);
        void dispose();
    };
}


#endif
